1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6# Keep the original TERM for say_color
7ORIGINAL_TERM=$TERM
8
9# For repeatability, reset the environment to known value.
10LANG=C
11LC_ALL=C
12PAGER=cat
13TZ=UTC
14TERM=dumb
15export LANG LC_ALL PAGER TERM TZ
16EDITOR=:
17VISUAL=:
18unset GIT_EDITOR
19unset AUTHOR_DATE
20unset AUTHOR_EMAIL
21unset AUTHOR_NAME
22unset COMMIT_AUTHOR_EMAIL
23unset COMMIT_AUTHOR_NAME
24unset EMAIL
25unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26unset GIT_AUTHOR_DATE
27GIT_AUTHOR_EMAIL=author@example.com
28GIT_AUTHOR_NAME='A U Thor'
29unset GIT_COMMITTER_DATE
30GIT_COMMITTER_EMAIL=committer@example.com
31GIT_COMMITTER_NAME='C O Mitter'
32unset GIT_DIFF_OPTS
33unset GIT_DIR
34unset GIT_WORK_TREE
35unset GIT_EXTERNAL_DIFF
36unset GIT_INDEX_FILE
37unset GIT_OBJECT_DIRECTORY
38unset SHA1_FILE_DIRECTORIES
39unset SHA1_FILE_DIRECTORY
40GIT_MERGE_VERBOSITY=5
41export GIT_MERGE_VERBOSITY
42export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
44export EDITOR VISUAL
45
46# Protect ourselves from common misconfiguration to export
47# CDPATH into the environment
48unset CDPATH
49
50case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
51 1|2|true)
52 echo "* warning: Some tests will not work if GIT_TRACE" \
53 "is set as to trace on STDERR ! *"
54 echo "* warning: Please set GIT_TRACE to something" \
55 "other than 1, 2 or true ! *"
56 ;;
57esac
58
59# Each test should start with something like this, after copyright notices:
60#
61# test_description='Description of this test...
62# This test checks if command xyzzy does the right thing...
63# '
64# . ./test-lib.sh
65[ "x$ORIGINAL_TERM" != "xdumb" ] && (
66 TERM=$ORIGINAL_TERM &&
67 export TERM &&
68 [ -t 1 ] &&
69 tput bold >/dev/null 2>&1 &&
70 tput setaf 1 >/dev/null 2>&1 &&
71 tput sgr0 >/dev/null 2>&1
72 ) &&
73 color=t
74
75while test "$#" -ne 0
76do
77 case "$1" in
78 -d|--d|--de|--deb|--debu|--debug)
79 debug=t; shift ;;
80 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
81 immediate=t; shift ;;
82 -h|--h|--he|--hel|--help)
83 help=t; shift ;;
84 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
85 verbose=t; shift ;;
86 -q|--q|--qu|--qui|--quie|--quiet)
87 quiet=t; shift ;;
88 --no-color)
89 color=; shift ;;
90 --no-python)
91 # noop now...
92 shift ;;
93 *)
94 break ;;
95 esac
96done
97
98if test -n "$color"; then
99 say_color () {
100 (
101 TERM=$ORIGINAL_TERM
102 export TERM
103 case "$1" in
104 error) tput bold; tput setaf 1;; # bold red
105 skip) tput bold; tput setaf 2;; # bold green
106 pass) tput setaf 2;; # green
107 info) tput setaf 3;; # brown
108 *) test -n "$quiet" && return;;
109 esac
110 shift
111 echo "* $*"
112 tput sgr0
113 )
114 }
115else
116 say_color() {
117 test -z "$1" && test -n "$quiet" && return
118 shift
119 echo "* $*"
120 }
121fi
122
123error () {
124 say_color error "error: $*"
125 trap - exit
126 exit 1
127}
128
129say () {
130 say_color info "$*"
131}
132
133test "${test_description}" != "" ||
134error "Test script did not set test_description."
135
136if test "$help" = "t"
137then
138 echo "$test_description"
139 exit 0
140fi
141
142exec 5>&1
143if test "$verbose" = "t"
144then
145 exec 4>&2 3>&1
146else
147 exec 4>/dev/null 3>/dev/null
148fi
149
150test_failure=0
151test_count=0
152
153trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
154
155test_tick () {
156 if test -z "${test_tick+set}"
157 then
158 test_tick=1112911993
159 else
160 test_tick=$(($test_tick + 60))
161 fi
162 GIT_COMMITTER_DATE="$test_tick -0700"
163 GIT_AUTHOR_DATE="$test_tick -0700"
164 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
165}
166
167# You are not expected to call test_ok_ and test_failure_ directly, use
168# the text_expect_* functions instead.
169
170test_ok_ () {
171 test_count=$(expr "$test_count" + 1)
172 say_color "" " ok $test_count: $@"
173}
174
175test_failure_ () {
176 test_count=$(expr "$test_count" + 1)
177 test_failure=$(expr "$test_failure" + 1);
178 say_color error "FAIL $test_count: $1"
179 shift
180 echo "$@" | sed -e 's/^/ /'
181 test "$immediate" = "" || { trap - exit; exit 1; }
182}
183
184
185test_debug () {
186 test "$debug" = "" || eval "$1"
187}
188
189test_run_ () {
190 eval >&3 2>&4 "$1"
191 eval_ret="$?"
192 return 0
193}
194
195test_skip () {
196 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
197 this_test="$this_test.$(expr "$test_count" + 1)"
198 to_skip=
199 for skp in $GIT_SKIP_TESTS
200 do
201 case "$this_test" in
202 $skp)
203 to_skip=t
204 esac
205 done
206 case "$to_skip" in
207 t)
208 say_color skip >&3 "skipping test: $@"
209 test_count=$(expr "$test_count" + 1)
210 say_color skip "skip $test_count: $1"
211 : true
212 ;;
213 *)
214 false
215 ;;
216 esac
217}
218
219test_expect_failure () {
220 test "$#" = 2 ||
221 error "bug in the test script: not 2 parameters to test-expect-failure"
222 if ! test_skip "$@"
223 then
224 say >&3 "expecting failure: $2"
225 test_run_ "$2"
226 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
227 then
228 test_ok_ "$1"
229 else
230 test_failure_ "$@"
231 fi
232 fi
233 echo >&3 ""
234}
235
236test_expect_success () {
237 test "$#" = 2 ||
238 error "bug in the test script: not 2 parameters to test-expect-success"
239 if ! test_skip "$@"
240 then
241 say >&3 "expecting success: $2"
242 test_run_ "$2"
243 if [ "$?" = 0 -a "$eval_ret" = 0 ]
244 then
245 test_ok_ "$1"
246 else
247 test_failure_ "$@"
248 fi
249 fi
250 echo >&3 ""
251}
252
253test_expect_code () {
254 test "$#" = 3 ||
255 error "bug in the test script: not 3 parameters to test-expect-code"
256 if ! test_skip "$@"
257 then
258 say >&3 "expecting exit code $1: $3"
259 test_run_ "$3"
260 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
261 then
262 test_ok_ "$2"
263 else
264 test_failure_ "$@"
265 fi
266 fi
267 echo >&3 ""
268}
269
270# This is not among top-level (test_expect_success | test_expect_failure)
271# but is a prefix that can be used in the test script, like:
272#
273# test_expect_success 'complain and die' '
274# do something &&
275# do something else &&
276# test_must_fail git checkout ../outerspace
277# '
278#
279# Writing this as "! git checkout ../outerspace" is wrong, because
280# the failure could be due to a segv. We want a controlled failure.
281
282test_must_fail () {
283 "$@"
284 test $? -gt 0 -a $? -le 128
285}
286
287# Most tests can use the created repository, but some may need to create more.
288# Usage: test_create_repo <directory>
289test_create_repo () {
290 test "$#" = 1 ||
291 error "bug in the test script: not 1 parameter to test-create-repo"
292 owd=`pwd`
293 repo="$1"
294 mkdir "$repo"
295 cd "$repo" || error "Cannot setup test environment"
296 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
297 error "cannot run git init -- have you built things yet?"
298 mv .git/hooks .git/hooks-disabled
299 cd "$owd"
300}
301
302test_done () {
303 trap - exit
304 case "$test_failure" in
305 0)
306 # We could:
307 # cd .. && rm -fr trash
308 # but that means we forbid any tests that use their own
309 # subdirectory from calling test_done without coming back
310 # to where they started from.
311 # The Makefile provided will clean this test area so
312 # we will leave things as they are.
313
314 say_color pass "passed all $test_count test(s)"
315 exit 0 ;;
316
317 *)
318 say_color error "failed $test_failure among $test_count test(s)"
319 exit 1 ;;
320
321 esac
322}
323
324# Test the binaries we have just built. The tests are kept in
325# t/ subdirectory and are run in trash subdirectory.
326PATH=$(pwd)/..:$PATH
327GIT_EXEC_PATH=$(pwd)/..
328GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
329GIT_CONFIG=.git/config
330export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
331
332GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
333export GITPERLLIB
334test -d ../templates/blt || {
335 error "You haven't built things yet, have you?"
336}
337
338if ! test -x ../test-chmtime; then
339 echo >&2 'You need to build test-chmtime:'
340 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
341 exit 1
342fi
343
344# Test repository
345test=trash
346rm -fr "$test"
347test_create_repo $test
348cd "$test"
349
350this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
351for skp in $GIT_SKIP_TESTS
352do
353 to_skip=
354 for skp in $GIT_SKIP_TESTS
355 do
356 case "$this_test" in
357 $skp)
358 to_skip=t
359 esac
360 done
361 case "$to_skip" in
362 t)
363 say_color skip >&3 "skipping test $this_test altogether"
364 say_color skip "skip all tests in $this_test"
365 test_done
366 esac
367done